#include <sys/stat.h>
#include <err.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>

int main(int argc, char*argv[])
{

	printf("(uid, euid) = (%d, %d)\n", getuid(), geteuid());

	char template[] = "/tmp/chflags.XXXXXX";
	char *tmpfile;

	tmpfile = mktemp(template);

	if (tmpfile == NULL)
		err(1, "mktemp");

	if (close(open(tmpfile, O_CREAT)))
		err(1, "close(open(..))");

	if (chflags(tmpfile, SF_ARCHIVED) != 0)
		warn("chflags");
	if (lchflags(tmpfile, SF_ARCHIVED) != 0)
		warn("lchflags");

	if (chflags(tmpfile, 0) != 0)
		err(1, "chflags(0)");
	else
		unlink(tmpfile);

	return (0);
}